/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Controller;

import DBConnection.DBConnection;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Vishal
 */
public class PayrollControl {
    public static ArrayList getPayroll_Present(int id)
    {
        Connection conn = DBConnection.getConnection();
        ArrayList toReturn = new ArrayList();
 
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Present_Payroll WHERE EmployeeId="+id+"");
        try
        {
            while (result.next()) {
                ArrayList temp = new ArrayList();
                temp.add(result.getString(3));
                temp.add(result.getString(4));
                temp.add(result.getString(5));
                toReturn.add(temp);
            }
        }
        catch (Exception e) { e.printStackTrace();}
        finally{
            DBConnection.closeConnection(conn);
            return toReturn;
        }
    }
    
    public static int releasePayment(int id, double hours)
    {
        return DBConnection.executeInsert("INSERT INTO Past_Payroll ( EmployeeId , Hours, ReleaseDate )"
                            + " VALUES (" + id + "," + hours + ",NOW())")
                + DBConnection.executeInsert("DELETE FROM Present_Payroll WHERE EmployeeId = " + id + " AND Active = 0");
    }
    
    public static String getTotalHours(int id)
    {
        Connection conn = DBConnection.getConnection();
        String toReturn = new String();
        ResultSet result = DBConnection.executeQuery(conn, "SELECT SUM(TIME_TO_SEC(Hours)) FROM Present_Payroll WHERE EmployeeId=" + id + " AND Active = 0");
        try
        {
            while (result.next()) {
                toReturn = result.getString(1);
            }
        }
        catch (Exception e) { e.printStackTrace();}
        finally{
            if(toReturn == null)
                toReturn = "0";
            DBConnection.closeConnection(conn);
            Double temp = Double.parseDouble(toReturn)/3600;
            temp = Math.round(temp*100.0)/100.0;
            toReturn = temp.toString();
            System.out.println(toReturn);
            return toReturn;
        }
    }
    
    public static int clockIn(int id)
    {
        return setActive(id) + DBConnection.executeInsert("INSERT INTO Present_Payroll ( EmployeeId , TimeIn, Active )"
                            + " VALUES (" + id + ", NOW()," + 1 + ")");
    }
    
    public static int clockOut(int id)
    {
        int temp =  setInactive(id) + DBConnection.executeInsert("UPDATE Present_Payroll SET TimeOut = NOW(), Active = " + 0
                + " WHERE EmployeeId = " + id + 
                " AND Active = " + 1);
        temp += DBConnection.executeInsert("UPDATE Present_Payroll SET Hours = TIMEDIFF(TimeOut, TimeIn) WHERE EmployeeId = " + id);
        
        return temp;
    }
    
    private static int setActive(int id)
    {
        return DBConnection.executeInsert("UPDATE Employee SET Active = " + 1
                + " WHERE idEmployee = " + id);
    }
    public static boolean isActive(int id)
    {
        Connection conn = DBConnection.getConnection();
        ArrayList toReturn = new ArrayList();
 
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Present_Payroll WHERE EmployeeId=" + id + " AND Active = " + 1);
        int count = 0;
        try
        {
            while (result.next()) {
                count++;
                break;
            }
        }
        catch (Exception e) { e.printStackTrace();}
        finally{
            DBConnection.closeConnection(conn);
            if(count > 0)
                return true;
            return false;
        }
    }
    
    private static int setInactive(int id)
    {
        return DBConnection.executeInsert("UPDATE Employee SET Active = " + 0
                + " WHERE idEmployee = " + id);
    }
}
