/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DBConnection;

import java.sql.SQLException;
import java.util.ArrayList;

/**
 *
 * @author Vishal
 */
public class DBConnectionPool {
    
    private static ArrayList<java.sql.Connection>  connections = new ArrayList();
    
    public DBConnectionPool getInstance()
    {
        return this;
    }
    
    public static java.sql.Connection aquireConnection() throws SQLException
    {
        for(java.sql.Connection conn:connections)
        {
            if(conn.isClosed())
            {
                conn = DBConnection.openConnection();
                return conn;
            }
        }
        java.sql.Connection conn = DBConnection.openConnection();
        connections.add(conn);
        return conn;
    }
    
    public static void releaseConnection(java.sql.Connection reusable)
    {
        int index = connections.indexOf(reusable);
        reusable = DBConnection.closeConnectionHelper(reusable);
        connections.set(index, reusable);
    }
}
