//
//  APIManager.h
//  AutoInformant
//
//  Created by Eric Gilbert on 4/7/12.
//  Copyright (c) 2012 Mercury Software. All rights reserved.
//

#import <Foundation/Foundation.h>
#define MENU_LOADED 1
#define ORDER_UPDATED 2
#define WAITER_TYPE 1
#define CUSTOMER_TYPE 2

@interface APIManager : NSObject <NSURLConnectionDelegate, NSURLConnectionDataDelegate, NSXMLParserDelegate>


@property (nonatomic, retain) NSMutableArray * menuArray;
@property (nonatomic, retain) NSMutableArray * searchResults;
@property (nonatomic, assign) int userType;

+ (id)sharedInstance;
- (void) getMenuItems;
-(void) saveOrder:(NSString *) employeeId customer:(NSString *)customerId orderList:(NSString *) orderList table:(NSString *) tableId timeStamp:(NSString *) dateString;
-(void) setTableToDirty:(NSString *) tableId;
-(void) setUserType:(int) type;
-(void) getOrderStatus:(NSString *) tableId timeStamp:(NSString *) timeStamp;
@end

