package Controller;

import DBConnection.*;
import java.sql.*;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Vishal
 */

public class EmployeeControl {
    
    /**Pull employee data from database in order to enumerate table on interface.
     * 
     * @return 
     */
    public static ArrayList<String>[] updateEmployeeList()
    {
        Connection conn = DBConnection.getConnection();
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Employee");
        ArrayList[] emp = new ArrayList[2];
        emp[0] = new ArrayList();
        emp[1] = new ArrayList();
        try {
            while (result.next()) {
                emp[0].add(result.getString(2) + " " + result.getString(3) + " " + result.getString(4));
                emp[1].add(result.getString(1));
            }
        } catch (Exception ex) {}
        DBConnection.closeConnection(conn);
        return emp;
    }
    
    /**Get all employee information for a specific employee based on id chosen in the interface and the idEmployee in the database.
     * 
     * @param id
     * @return 
     */
    public static String[] getEmployee(int id)
    {
        Connection conn = DBConnection.getConnection();
        String[] toReturn = new String[8];
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Employee WHERE idEmployee = " + id);
        try
        {
            while (result.next()) {
                toReturn[0] = (result.getString(2));
                toReturn[1] = (result.getString(3));
                toReturn[2] = (result.getString(4));
                toReturn[3] = (result.getString(5));
                toReturn[4] = (result.getString(6));
                toReturn[5] = (result.getString(7));
                toReturn[6] = (result.getString(8));
                toReturn[7] = (result.getString(9)); 
            }
        }
        catch (Exception e) { /* ignore close errors */ }
        finally{
            DBConnection.closeConnection(conn);
            return toReturn;
        }
    }
    
    /**Add an employee to the database with the information passed from the interface, which are the input parameters.
     * 
     * @param fname
     * @param mname
     * @param lname
     * @param SSN
     * @param wage
     * @param username
     * @param password
     * @param type
     * @return 
     */
    public static int addEmployee(String fname, String mname, String lname, long SSN, double wage, String username, String password, String type){
        int count = DBConnection.executeInsert("INSERT INTO Employee" 
                +"( FirstName , MiddleInitial , LastName , Wage , Username , Password , SSN , Type )"
                + " VALUES " 
                + "('" + fname + "','" + mname + "','" 
                + lname + "'," + wage + ",'" + username + "','" 
                + password + "'," + SSN + ",'" + type + "')");
        
        return count;
    }
    
    /**Edit an existing employee, where the id is the idEmployee in the database, with the information passed from the interface, which are the input parameters.
     * 
     * @param fname
     * @param mname
     * @param lname
     * @param SSN
     * @param wage
     * @param username
     * @param password
     * @param type
     * @param id
     * @return 
     */
    public static int editEmployee(String fname, String mname, String lname, long SSN, double wage, String username, String password, String type, int id){
        
        int count = DBConnection.executeInsert("UPDATE Employee SET FirstName = '" + fname 
                + "', MiddleInitial = '" + mname
                + "', LastName = '" + lname
                + "', Wage = " + wage
                + ", Username = '" + username
                + "', Password = '" + password
                + "', Type = '" + type
                + "', SSN = " + SSN
                + " WHERE idEmployee = " + id);
        
        return count;
    }
}
