package Controller;
import DBConnection.*;
import java.sql.*;
import java.util.ArrayList;
/**
 *
 * @author Vishal
 */
public class TableControl {
    
    /**Pulls the table data from the database and returns it to be displayed on the user interface.
     * 
     * @return 
     */
    public static ArrayList[] getTables()
    {
        Connection conn = DBConnection.getConnection();
        ArrayList[] toReturn = new ArrayList[4];
        for(int c = 0; c < 4; c++)
        {
            toReturn[c] = new ArrayList();
        }
        ResultSet result = DBConnection.executeQuery (conn, "SELECT * FROM Tables");
        int i = 0;
        try {
            while (result.next()) {
                toReturn[0].add(result.getString(1));
                toReturn[1].add(result.getString(2));
                toReturn[2].add(result.getString(3));
                toReturn[3].add(result.getString(4));
                i++;
            }
            
        } catch (Exception e) {}
        finally{
            DBConnection.closeConnection(conn);
            return toReturn;
        }
    }
    
    /**Updates the status of the table based on id of table chosen.
     * 
     * @param tableID
     * @param status
     * @return 
     */
    public static int updateStatus(int tableID, String status)
    {
        int count = DBConnection.executeInsert("UPDATE Tables SET status = '" + status
                + "' WHERE idTable = " + tableID);
        
        return count;
    }
    
    /**Adds a new table to the database.
     * 
     * @return 
     */
    public static int addTable()
    {
        int count = DBConnection.executeInsert("INSERT INTO Tables" 
                + "(status) VALUES ('clean')");
        
        return count;
    }

}
