//
//  CustomerOrderViewController.h
//  AutoServe
//
//  Created by Eric Gilbert on 3/28/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "MenuTableViewController.h"
@class CustomerOrderViewController;

@protocol TableListDelegate <NSObject>
- (void)SaveTableEntry:(NSMutableArray *)tableOrder;
- (void)RemoveTableEntry;
@end


@interface CustomerOrderViewController : UIViewController <UITableViewDelegate, UITableViewDataSource, CustomerOrderDelegate, UIAlertViewDelegate>
@property (nonatomic, assign) id <TableListDelegate> delegate;
@property (nonatomic, retain) NSMutableArray * tableOrderList;
@property (retain, nonatomic) IBOutlet UITableView *customerTableView;
@property (nonatomic,assign) int selectedTable;
@property (retain, nonatomic) IBOutlet UIBarButtonItem *payBillButton;
@property (retain, nonatomic) IBOutlet UIToolbar *orderToolBar;
@property (retain, nonatomic) IBOutlet UIBarButtonItem *middleSpacer;

- (IBAction)onPayBill:(id)sender;

- (IBAction)saveTableOrder:(id)sender;
- (void) loadTableOrder:(NSMutableArray *) tableOrder;

@end
