//
//  LoginViewController.m
//  AutoServe
//
//  Created by Eric Gilbert on 3/24/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "LoginViewController.h"

@interface LoginViewController ()

@end

@implementation LoginViewController
@synthesize usernameInput;
@synthesize passwordInput;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
}

- (void)viewDidUnload
{
    [self setUsernameInput:nil];
    [self setPasswordInput:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


#pragma mark Keyboard Delegates

- (void)registerForKeyboardNotifications 
{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWasShown:) name:UIKeyboardDidShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWasHidden:) name:UIKeyboardDidHideNotification object:nil];
}


- (void) registerForEditingEvents:(UIControl*)aControl{
    
    [aControl addTarget:self action:@selector(textFieldDidBeginEditing:)
     
       forControlEvents:UIControlEventEditingDidBegin];
    
    [aControl addTarget:self action:@selector(textFieldDidEndEditing:)
     
       forControlEvents:UIControlEventEditingDidEnd];
    
}

- (void)keyboardWasShown:(NSNotification*)aNotification
{
 
}

// Called when the UIKeyboardDidHideNotification is sent

- (void)keyboardWasHidden:(NSNotification*)aNotification
{
    
    //// NSDictionary* info = [aNotification userInfo]
    
}


- (IBAction)onUsernameCompleted:(id)sender 
{
    [self.usernameInput resignFirstResponder];
}

- (IBAction)onPasswordCompleted:(id)sender 
{
    [passwordInput resignFirstResponder]; 

}

#pragma mark -

- (void)dealloc {
    [usernameInput release];
    [passwordInput release];
    [super dealloc];
}
@end
