//
//  MenuTableViewController.h
//  AutoServe
//
//  Created by Eric Gilbert on 3/24/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
@class MenuTableViewController;

@protocol CustomerOrderDelegate <NSObject>
- (void)CustomerOrderDidSave:(MenuTableViewController *)controller;
@end

@interface MenuTableViewController : UITableViewController

@property (nonatomic, assign) id <CustomerOrderDelegate> delegate;
@property(nonatomic, retain) NSMutableDictionary *customerOrder;

- (IBAction)onSavePressed:(id)sender;
- (void) setOrder:(NSDictionary *) theOrder;

@end
/*prototype for public methods goes here */